
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% FDS.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function [point,info] = FDS(fun,point,step,par,tune,info)
% repeatedly impove function value by Delta
%
% for details of input and output structures see VSBBO.m
%
function [point,info] = FDS(fun,point,step,par,tune,info)

ngood = 0;

while 1
       point.grad0 = point.grad; point.xm0 = point.xm;
       if info.prt>=0,
          disp('=============')
          disp('start MLS')
          disp('=============')
       end
       [point,par,step,info] = MLS(fun,point,step,par,tune,info);
       if info.prt>=0,
          disp('=============')
          disp('end MLS')
          disp('=============')
       end
       if info.done, return; end;
       if info.prt>=0, nfFDS=info.nf, end;
       if ~ par.good, break; end
       ngood      = ngood+1;
       [point]    = updateXF(point,tune);
       [point]    = updateSY(point);
end
info.ngood = ngood;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
