
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% setScales.m %%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% function [point,step,par,info]=setScales(fun,point,step,par,tune,info)
% estimate Deltamax and s
%
% for details of input and output structures see VSBBO.m
%
function [point,step,par,info] = setScales(fun,point,step,par,tune,info)
 
% get and regularize first function value
info.nf=1;
point.x = max(point.low,min(point.upp,point.x));
fnew = fun(point.x);
if isnan(fnew), fnew=inf; end;
point.f=max(-1e50,min(fnew,1e50));
if point.f==0 | isinf(point.f), next; end
% get initial values for subspace 
point.F = point.f; 
point.xm = point.x; point.fm = point.f; 
point.b = 1; point.m =1;
% get initial values for T
par.T = tune.C+tune.R+tune.S+2; par.ss = 0; par.lam = 0; 


step.deltamin = tune.deltamin;
step.deltamax = tune.deltamax;

step.delta    = tune.deltamin;  
step.Delta    = step.Deltamax;
   
info.nf    = 1;
par.A      = ones(par.T,1);
step.Delta = tune.Deltamax;	
point.fext = point.fm;

step.deltamin = tune.deltamin;
step.deltamax = tune.deltamax;
step.s        = ones(point.n,1);

point.S = zeros(point.n,point.m); % m previous parameter values
point.Y = zeros(point.n,point.m); % m previous gradient values
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%             get X in order to estimate Deltamax                % 
%             MLS doesn't use subspace direction                 %  
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
point.col=0;
for tt=1:tune.T0
    point.tt=tt;
    if tt>=2, point.grad0 = point.grad; point.xm0 = point.xm; end
    if info.prt>=0,
      disp('=============')
      disp('start MLS')
      disp('=============')
    end
   [point,par,step,info] = MLS(fun,point,step,par,tune,info);
   if info.prt>=0,
     disp('==============')
     disp('end MLS')
     disp('==============')
   end
   [point] = updateXF(point,tune);             
   if info.done, return; end;
   if info.prt>=0, nfSS=info.nf, end;
   if tt>=2, [point] = updateSY(point); end
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                get maximal desied gain Deltamax                %      
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
par.ss = 1;
II  = setdiff(1:point.m,point.b);
XX  = point.X(:,II);

for i=1:point.m-1
    dX(:,i)  = XX(:,i)-point.X(:,point.b);
end

step.s = max(dX')'; step.s(step.s==0) = 1;

dF = median(abs(point.F-point.F(point.b))); 

if dF==0
    step.Deltamax = tune.gammamax;
    step.Delta    = step.Deltamax;
    par.lam       = (tune.gammalambda)/sqrt(point.n);
else
    step.Deltamax = tune.gammamax*min(dF,1);
    step.Delta    = step.Deltamax;
    par.lam       = (tune.gammalambda)*dF/sqrt(point.n);
end


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
